<?php
namespace Auth;

use pocketmine\player\Player;
use pocketmine\player\GameMode;
use pocketmine\utils\Config;
use pocketmine\event\Listener;
use pocketmine\command\Command;
use pocketmine\utils\TextFormat;
use pocketmine\plugin\PluginBase;
use pocketmine\command\CommandSender;
use pocketmine\event\player\PlayerJoinEvent;
use pocketmine\event\player\PlayerChatEvent;
use pocketmine\event\player\PlayerQuitEvent;
use pocketmine\event\player\PlayerMoveEvent;
use pocketmine\event\player\PlayerCommandPreprocessEvent;
use jojoe77777\FormAPI;
use Auth\utils\CallbackTask;

class Auth extends PluginBase implements Listener{

	public $login = [];
	
	public function onEnable() : void{
		$this->getServer()->getPluginManager()->registerEvents($this, $this);
		$this->opros = new Config($this->getDataFolder()."opros.json",Config::JSON);
		$this->exec();

	}

    public function exec(){
        $this->getLogger()->info(TextFormat::YELLOW."(Multi-Serv) Working...");

        @mkdir($this->getDataFolder());
        @mkdir($this->getDataFolder()."Players");
        
        $this->saveDefaultConfig();
        $this->getResource("config.yml");

        $this->HOST = $this->getConfig()->get("HOST");

        if($this->getConfig()->get("mysqli.work.?") != false){
            
            $this->getLogger()->info(TextFormat::GREEN."Mysql is activated.");

            $this->USER = $this->getConfig()->get("USER");
            $this->PASS = $this->getConfig()->get("PASS");

            $this->TABLE = "Auth"."(PLAYER VARCHAR(255), IP VARCHAR(30), PASSWORD VARCHAR(65536))";

            $mysqli = new \mysqli($this->HOST, $this->USER, $this->PASS);
                $mysqli->query("CREATE DATABASE IF NOT EXISTS "."Auth");

            $mysqli = new \mysqli($this->HOST, $this->USER, $this->PASS, "Auth");
                $mysqli->query("CREATE TABLE IF NOT EXISTS ".$this->TABLE);

        }else{
            $this->getLogger()->info(TextFormat::GOLD."Mysql is disabled, check in config.yml if you want activate it.");

        }

    }


	public function Join(PlayerJoinEvent $event){
		$player = $event->getPlayer();

		$this->login[$player->getName()] = false;

	 	if($this->isRegister($player) == true){ //Player is register ?

			if($this->isLoginIp($player) == true){ // Player is login ip ?
				$this->isLogin($player, true);

				$this->login[$player->getName()] = true;

				$player->sendMessage($this->getConfig()->get("login.success.ip.message"));
				$player->sendPopup($this->getConfig()->get("login.success.ip.message"));
				$player->sendTitle("Вход по IP..");

			}else{
				$this->isLogin($player, false);
				$player->sendMessage($this->getConfig()->get("login.join.message"));
				$player->sendPopup($this->getConfig()->get("login.join.message"));
				$player->sendTitle("§eПодождите","Вам нужно авторизироватся!");
				$this->loginUI($player);
				//$this->getScheduler()->scheduleDelayedTask(new CallbackTask (array($this, "loginUI"), array($player)), 20 * 4);
 
            }

	 	}else{
            $this->isLogin($player, false);
			//$this->licenseUI($player);
			$this->registerUI($player);
            $player->sendMessage($this->getConfig()->get("register.join.message"));
	    $player->sendPopup($this->getConfig()->get("register.join.message"));
		$player->sendTitle("§aПодождите","Вам нужно зарегистрироватся!");

		}
	}
	
	
	
	  /*public function replaceUI(PlayerMoveEvent $event){
		$player = $event->getPlayer();
		if($this->isRegister($player) == false){
			$this->registerUI($player);
		}
		if($this->isRegister($player) == true){
		if($this->isLoginIp($player) == false){ 
				$this->loginUI($player);
	  }
	  }
	  э}*/
	  


	
	 public function loginUI(Player $player){
		$api = $this->getServer()->getPluginManager()->getPlugin("FormAPI");
		$form = $api->createSimpleForm(function ($player, $data){
			- $id = $data[0]; + $id = $data;
			if($id == 0){
			$player->close("Вам нужно войти в аккаунт", "Вам нужно войти в аккаунт");
		}
		if($id == 1){
			
			
			
			
			$api = $this->getServer()->getPluginManager()->getPlugin("FormAPI");
			$form = $api->createCustomForm(function ($player, $data){
		if (isset($data['password'])) {
			$password = $data['password'];
	
				 if($player instanceOf Player && $this->isRegister($player) == true && $this->login[$player->getName()] == false){
                    
                	if($this->Login($player, $password) == true){
                        $this->isLogin($player, true);
                        $this->changeIp($player);


                        $this->login[$player->getName()] = true;

                        $player->sendMessage($this->getConfig()->get("login.success.message"));
			$player->sendTitle("§aВы авторизировались");

                	}else{
                		$player->sendMessage($this->getConfig()->get("login.error.message"));
						$this->loginUI($player);

                	}

                }
	
              
        }
		
		if($data == 0){
			$this->loginUI($player);
		}
		if($data == null){
			$this->loginUI($player);
		}
		
		});
        $form->setTitle("Авторизация");
		$form->addInput('', 'Введите пароль', null, 'password');
        $form->sendToPlayer($player);
			
			
			
			
			
			

		}

        });
        $form->setTitle("Авторизация");
        $form->setContent("Данный никнейм уже зарегестрирован, авторизуйтесь.");
		$form->addButton("Войти", -1, "", "1");
        $form->sendToPlayer($player);
			
	
   
}





public function vote($type){
	$config = new Config($this->getDataFolder() ."vote.yml", Config::YAML);
	$config->set($type, $config->get($type) + 1);
	$config->save();
}




 public function registerUI(Player $player) {
			
			$api = $this->getServer()->getPluginManager()->getPlugin("FormAPI");
			$form = $api->createCustomForm(function ($player, $data){
		if (isset($data['password'])) {
			$password = $data['password'];
	
				if($player instanceOf Player && $this->isRegister($player) == false && $this->login[$player->getName()] == false){

                	if(!empty($password)){
                		$this->Register($player, $password);
                		$this->isLogin($player, true);

                        $this->login[$player->getName()] = true;

                        $player->sendMessage($this->getConfig()->get("register.success.message"));
						$player->sendTitle("§aУспешно!");
						$cfg = new Config($this->getDataFolder() ."registers.yml", Config::YAML);
						$cfg->set(date("d.m.y"), $cfg->get(date("d.m.y")) + 1);
						$cfg->save();
                	}else{
                		$player->sendMessage($this->getConfig()->get("register.error.message"));

                	}

                }
  
        }
		if($data == 0){
			$this->registerUI($player);
		}
		if($data == null){
			$this->registerUI($player);
		}
		});
        $form->setTitle("Регистрация");
		$form->addInput('', 'Введите новый пароль', null, 'password');
        $form->sendToPlayer($player);
	
}


	
	public function onCommand(CommandSender $sender, Command $command, string $label, array $args):bool{

		switch($command->getName()){

            case "register": //all
                if($sender instanceOf Player && $this->isRegister($sender) == false && $this->login[$sender->getName()] == false){

                	if(!empty($args[0])){
                		$this->Register($sender, $args[0]);
                		$this->isLogin($sender, true);

                        $this->login[$sender->getName()] = true;

                        $sender->sendMessage($this->getConfig()->get("register.success.message"));
						$sender->sendTitle("Вы зарегистрировались");

                	}else{
                		$sender->sendMessage($this->getConfig()->get("register.error.message"));

                	}

                }
            break;

            case "login": //all
                if($sender instanceOf Player && $this->isRegister($sender) == true && $this->login[$sender->getName()] == false){
                    
                	if(!empty($args[0]) && $this->Login($sender, $args[0]) == true){
                        $this->isLogin($sender, true);
                        $this->changeIp($sender);

                        $this->login[$sender->getName()] = true;

                        $sender->sendMessage($this->getConfig()->get("login.success.message"));
			$sender->sendTitle("§aВы авторизировались");

                	}else{
                		$sender->sendMessage($this->getConfig()->get("login.error.message"));

                	}

                }
            break;
            case "howmanyregister":
            	if($sender->isOp()){
            		$cfg = new Config($this->getDataFolder() ."registers.yml", Config::YAML);
            		$sender->sendMessage("".$cfg->get(date("d.m.y")));
            	}
            break;
            case "unregister": //op

                	if($this->unRegister($args[0]) == true){
                        $sender->sendMessage($this->getConfig()->get("unregister.success.message"));

                    }else{
                    	$sender->sendMessage($this->getConfig()->get("unregister.error.message"));

                    }

            break;

        }
	return true;

    }


	public function isRegister(Player $player){
        $name = $player->getName();

        if($this->getConfig()->get("mysqli.work.?") == false){

		    if(file_exists($this->getDataFolder()."Players"."/".$name.".yml")){
                return true;
			
            }else{
			    return false;

            }

        }else{
            $mysqli = new \mysqli($this->HOST, $this->USER, $this->PASS, "Auth");

            if($mysqli->query("SELECT * FROM "."Auth"." WHERE PLAYER = '$name'")->num_rows > 0){
                return true;
            
            }else{
                return false;

            }

        }

	}

	public function isLoginIp(Player $player){
        $address = $player->getNetworkSession()->getIP();
        $name = $player->getName();

        if($this->getConfig()->get("mysqli.work.?") == false){

            $file = new Config($this->getDataFolder()."Players"."/".$name.".yml", Config::YAML);

            if($address == $file->get("IP")){
			    return true;
			
		    }else{
			    return false;

            }

        }else{
            $mysqli = new \mysqli($this->HOST, $this->USER, $this->PASS, "Auth");
            $info = mysqli_fetch_row($mysqli->query("SELECT * FROM "."Auth"." WHERE PLAYER = '$name'"));

            if($address == $info[1]){
                return true;
            
            }else{
                return false;

            }

        }



	}

	public function isLogin(Player $player, $valid){
		if($valid){
			$player->setImmobile(false);
			$player->setGamemode(GameMode::SURVIVAL());
		}else{
			$player->setImmobile();
			$player->setGamemode(GameMode::SPECTATOR());
			
		}
    }
	
		public function isLogincmd(PlayerCommandPreprocessEvent $event) {
			$player = $event->getPlayer();
    		if($this->login[$player->getName()] == false){
				$event->cancel();
			}
		}
		
		
		
		public function MsgDeny(PlayerChatEvent $event){
			$player = $event->getPlayer();
			if($this->login[$player->getName()] == false){ 
				$player->sendMessage("§cЗапрещено писать сообщения неавторизированным!");
				$event->cancel();
			}
		}
		
		
		

    public function changeIp(Player $player){
        $address = $player->getNetworkSession()->getIP();
        $name = $player->getName();

        if($this->getConfig()->get("mysqli.work.?") == false){

            $file = new Config($this->getDataFolder()."Players"."/".$player->getName().".yml", Config::YAML);

            $file->set("IP", $address);
            $file->save();

        }else{
            $mysqli = new \mysqli($this->HOST, $this->USER, $this->PASS, "Auth");

            $mysqli->query("UPDATE "."Auth"." SET IP = '$address' WHERE PLAYER = '$name'");

        }

    }

    public function Register(Player $player, $password){
        $address = $player->getNetworkSession()->getIP();
        $name = $player->getName();
        $passmd5 = $password;

        if($this->getConfig()->get("mysqli.work.?") == false){

            $file = new Config($this->getDataFolder()."Players"."/".$player->getName().".yml", Config::YAML);

            $file->set("IP", $player->getNetworkSession()->getIP());
            $file->set("PASSWORD", $passmd5);
            $file->save();

        }else{
            $mysqli = new \mysqli($this->HOST, $this->USER, $this->PASS, "Auth");

            $mysqli->query("INSERT INTO "."Auth"."(PLAYER, IP, PASSWORD) VALUES ('$name', '$address', '$passmd5')");

        }

    }

    public function Login(Player $player, $password){
        $name = $player->getName();
        $passmd5 = $password;

        if($this->getConfig()->get("mysqli.work.?") == false){

		    $file = new Config($this->getDataFolder()."Players"."/".$name.".yml", Config::YAML);

		    if($passmd5 == $file->get("PASSWORD")){
                return true;
			
		    }else{
			    return false;

            }

        }else{
            $mysqli = new \mysqli($this->HOST, $this->USER, $this->PASS, "Auth");
            $info = mysqli_fetch_row($mysqli->query("SELECT PLAYER, IP, PASSWORD FROM "."Auth"." WHERE PLAYER = '$name'"));

            if($passmd5 == $info[2]){
                return true;
            
            }else{
                return false;

            }

        }

	}

    public function unRegister($name){
        $i = $this->getServer()->getPlayerByPrefix($name);

        if($i){
            $i->kick($this->getConfig()->get("kick.player.message"));

        }

        if($this->getConfig()->get("mysqli.work.?") == false){

            if(file_exists($this->getDataFolder()."Players"."/".$name.".yml")){
                unlink($this->getDataFolder()."Players"."/".$name.".yml");

                return true;

            }else{
                return false;

            }
   
        }else{
            $mysqli = new \mysqli($this->HOST, $this->USER, $this->PASS, "Auth");

            if($mysqli->query("SELECT * FROM "."Auth"." WHERE PLAYER = '$name'")->num_rows > 0){
                $mysqli->query("DELETE FROM "."Auth"." WHERE PLAYER = '$name'");

                return true;
            
            }else{
                return false;

            }

        }

    }

  
}





